#include<iostream>
#include<algorithm>

using namespace std;

int kom[1005],k,mx,j,r[1005],l,p,u;

int main()
{
    cin>>k;
    for(int i=3;i<=845;i++)
        kom[i]=i*(i-1)*(i-2)/6;
    j=844;
    l=0;
    while(k>0)
        if(k>=kom[j]){
            r[++l]=j;
            k-=kom[j];
            u+=j;
        }
        else
            j--;
    cout<<u<<endl;
    p=1;
    for(int i=1;i<=l;i++)
    {
        for(int m=1;m<=r[i];m++)
        {
            cout<<i<<" "<<p<<endl;
            p++;
        }
        p+=i*1000;
    }

    return 0;
}